darcs-2.12.5: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.Patch.Prim.V1.Commute

Contents

- Orphan instances

# Documentation

data Perhaps a #

Constructors

Unknown |
Failed |
Succeeded a |

Instances

Monad Perhaps # |
Methods (>>=) :: Perhaps a -> (a -> Perhaps b) -> Perhaps b # (>>) :: Perhaps a -> Perhaps b -> Perhaps b # return :: a -> Perhaps a # fail :: String -> Perhaps a #
Functor Perhaps # |
Methods fmap :: (a -> b) -> Perhaps a -> Perhaps b # (<$) :: a -> Perhaps b -> Perhaps a #
Applicative Perhaps # |
Methods pure :: a -> Perhaps a # (<*>) :: Perhaps (a -> b) -> Perhaps a -> Perhaps b # (*>) :: Perhaps a -> Perhaps b -> Perhaps b # (<*) :: Perhaps a -> Perhaps b -> Perhaps a #
Alternative Perhaps # |
Methods empty :: Perhaps a # (<|>) :: Perhaps a -> Perhaps a -> Perhaps a # some :: Perhaps a -> Perhaps [a] # many :: Perhaps a -> Perhaps [a] #
MonadPlus Perhaps # |
Methods mzero :: Perhaps a # mplus :: Perhaps a -> Perhaps a -> Perhaps a #

subcommutes :: [(String, WrappedCommuteFunction)] #

newtype WrappedCommuteFunction #

Constructors

WrappedCommuteFunction |
Fields runWrappedCommuteFunction :: CommuteFunction

# Orphan instances

Commute Prim # |
Methods commute :: (Prim :> Prim) wX wY -> Maybe ((Prim :> Prim) wX wY) #